'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (layers) {
	var api = getApiUnion(layers);
	var handler = getHandler(api, layers);
	return new Proxy({}, handler);
};

function getHandler(api, layers) {
	return {
		get: function get(target, name) {
			if (api.has(name)) {
				return function () {
					for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
						args[_key] = arguments[_key];
					}

					var promises = [];
					layers.forEach(function (layer) {
						return promises.push(layer[name].apply(layer, args));
					});

					if (layers.length === 1) {
						return promises[0];
					}
					return Promise.all(promises);
				};
			}
		}
	};
}

function getApiUnion() {
	return new Set(['readFile', 'writeFile']);
}
